#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue May  4 14:29:35 2021

@author: Mathilde
"""

### TD Image

import numpy as np

## Q1

def niveau_gris(M):
    """
    La fonction prend en entrée une image codée en RGB, représentée
    par un tableau à 3 dimensions (n,p,3) où n*p correspond au nombre
    de pixels. Elle renvoie une image en niveaux de gris de taille n*p
    """
    n,p,q=np.shape(M) # Le tableau M a 3 dimensions n, p et q (avec q=3)
    P=np.zeros((n,p)) # on crée un tableau P de taille n*p
    for i in range(n): # on parcourt les colonnes du tableau M
        for j in range(p): # on parcourt les lignes du tableau M
            P[i][j]=int(0.299*M[i][j][0]+0,587*M[i][j][1]+0,144*M[i][j][2])
    # Pour chaque pixel de M situé à la colonne i et la ligne j,
    # on fait la moyenne des valeurs du pixel rouge, du pixel bleu 
    # et du pixel vert. On met cette valeur à la position i,j dans le 
    # nouveau P 
    return P


### Q2
    
def negatif(A):
    """
    Cette fonction prend en entrée une image codée en niveaux de gris et
    renvoie son négatif en niveaux de gris
    """
    x,y = np.shape(A) # x et y sont les dimensions du tableau A
    Neg=np.zeros((x,y)) # on crée un nouveau tableau
    for i in range(x):
        for j in range(y): # on parcourt tous les pixels du tableau
            Neg[i][j]=255-A[i][j] # de départ et pour chaque pixel, 
            # on le remplace par son négatif dans le nouveau tableau
    return Neg

### Q3

def flipV(A):
    """
    Cette fonction prend en entrée une image codée en niveaux de gris et
    renvoie l'image obtenue par symétrie d'axe vertical passant par le 
    milieu de l'image
    """
    x,y=np.shape(A) # x et y sont les dimensions du tableau A
    A_flipV=np.zeros((x,y)) # on crée un nouveau tableau
    for i in range(x):
        for j in range(y): # on parcourt tous les pixels du tableau de départ
            A_flipV[i][j]=A[x-i-1][j] # le pixel ne change pas de ligne
            # mais il se retrouve sur la x-i ème colonne s'il était 
            # sur la ième colonne
    return A_flipV



